// Uebung4 Betriebssysteme 2
// Matthias Jauernig, 2006
// Client-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SOCKNAME "sockunix"

#define Fflush() while(getchar() != '\n')

char* readFile(){
	char* filename = (char*)malloc(100*sizeof(char));
	printf("Datei, in welcher die Daten zu speichern sind: ");
	scanf("%s", filename);
	Fflush();
	return filename;
}

int main(int argc, char** argv){
	FILE* fp;			// Pointer auf File
	char* textfile = NULL;		// Dateiname
	int sockd, l, sl;
	struct sockaddr_un uxadr; // Bereich fuer Adressinformation
	char eab[100]; // E/A-Bereich

	// Adressinformationen bereitstellen
	uxadr.sun_family = AF_UNIX;
	strcpy(uxadr.sun_path, SOCKNAME);	// File fuer Datenaustausch eintragen

	// Socket einrichten
	if((sockd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0){
		perror("socket");
		return 1;
	}	

	// Verbindung zum Server herstellen
	sl = sizeof(uxadr);
	if(connect(sockd, (struct sockaddr*)&uxadr, sl) < 0){
		perror("connect");
		return 2;
	}

	if(argc==2){	// Dateiname uebergeben
		textfile = argv[1];
	}
	else if(argc==1){	// Dateiname von stdin lesen
		textfile = readFile();
	}
	else{		// Benutzungsmeldung ausgeben
		printf("Benutzung: %s [textfile]\n", argv[1]);
		return 4;
	}

	// pruefen ob Datei existiert
	if((fp = fopen(textfile, "r")) == NULL){
		if(errno != ENOENT){	// Datei existiert, konnte aber nicht geoeffnet werden
			perror("fopen(r)");
			return 5;
		}
		// ansonsten: Datei existiert nicht, alles klar
	}
	else{ // Datei existiert -> Benutzerabfrage auf Ueberschreiben
		fclose(fp);
		char abfrage;
		printf("Die Datei %s existiert bereits - soll sie ueberschrieben werden (j/n)?: ", textfile);
		scanf("%c", &abfrage);
		Fflush();
		if(toupper(abfrage)=='J'){ // soll ueberschrieben werden
			if((fp = fopen(textfile, "w")) == NULL){ // versuche zum Schreiben zu oeffnen
				perror("fopen(w)");	// Fehler
				return 6;
			}
			else{	// alles klar
				fclose(fp);
			}
			
		}
		else{ // soll nicht ueberschrieben werden
			printf("Ende...\n");
			return 0;
		}
	}

	// als erste Nachricht Dateiname uebermitteln
	if((l = send(sockd, textfile, strlen(textfile)+1, 0)) < 0){
		perror("send");
		return 7;
	}

	printf("Text eingeben\n");
	printf(": ");
	while((fgets(eab, 100, stdin)) != NULL){
		if((l = send(sockd, eab, strlen(eab)+1, 0)) < 0){
			perror("send");
			return 8;
		}
		if(recv(sockd, eab, 100, 0) < 0){
			perror("recv");
			return 9;
		}
		printf("Nachricht mit %d Bytes gesendet, %s Bytes empfangen\n", l, eab);
		printf(": ");
	}
	printf("\n");

	// Socketdeskriptor schließen
	if(close(sockd) < 0){
		perror("close");
		return 10;
	}
	
	return 0;
}
